<template>
  <div class="login-bg">
    <h1>Narzędziownia</h1>
    <input-form class="login-form" v-on:model-submit="on_submit">
      <input-text-field
        :error="get_error_for('email')"
        :size="2"
        name="Email"
        v-model="email"
        :icon="icons.faAt"
      />
      <input-text-field
        :error="get_error_for('password')"
        :size="2"
        name="Hasło"
        v-model="password"
        :icon="icons.faKey"
        type="password"
      />
      <div
        v-for="error in errors.filter((e) => e.field == null)"
        :style="{ gridColumnEnd: `span 2` }"
        :key="error.error"
        class="error"
      >
        {{ error.error }}
      </div>
      <input-button :size="2" :spinner="status == formStatus.sending">
        Zaloguj się</input-button
      >
    </input-form>
  </div>
</template>

<script lang="ts">
import { useRouter } from "vue-router";
import { Options } from "vue-class-component";

import InputButton from "@/components/input/InputButton.vue";
import InputForm from "@/components/input/InputForm.vue";
import InputTextField from "@/components/input/InputTextField.vue";

import { faKey, faAt } from "@fortawesome/free-solid-svg-icons";
import NewRecord from "@/views/new-views/NewRecord";
import { NApi } from "@/interfaces/connector";

@Options({
  components: {
    InputButton,
    InputForm,
    InputTextField,
  },
  emits: ["model-reload"],
})
export default class LoginView extends NewRecord<
  { email: string; password: string },
  void
> {
  public email = "";
  public password = "";
  public router = useRouter();

  public API_CALL = NApi.login;

  public icons = {
    faAt,
    faKey,
  };

  public get_data = () => ({
    email: this.email,
    password: this.password,
  });

  public on_sent = async () => {
    await this.router.push("/osoby");
  };
}
</script>

<style lang="scss" scoped>
@import "@/styles/globals";

.login-bg {
  width: 100%;
  height: 100%;
  background-color: $light_bg;

  h1 {
    display: block;
    margin: 0;
    color: $black_text;
    font-size: 40px;
    padding: $list_spacing;
    padding-top: calc(100vh / 2 - 170px);
  }

  .login-form {
    max-width: $max_list_width/2;
    margin: auto;
  }

  .error {
    color: $red;
    font-size: 10px;
  }
}
</style>
